<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities\Util;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\Session\Session;


class ObjetivoVenda extends \Teknisa\MAN\Controllers\TeknisaCrud {
    
    protected $dataSourceName = 'vnd10000_objetivovenda';
    protected $environment;
    protected $crudService;
    protected $ObjetivoVendaService;
    
    public function __construct($crudService, $environment, $ObjetivoVendaService) {
        $this->crudService =$crudService;
        $this->environment = $environment;
        $this->ObjetivoVendaService = $ObjetivoVendaService;
    }
    
    public function findObjetivoVendaMensal(DTO\Request $request, DTO\Response $response){
        parent::find($request,$response);
    }
    
    
    public function findObjetivoVendaDiaria(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10000_objetivovenda_dia';
        parent::find($request,$response);
    }
    
    public function saveObjetivoVendaDiaria(DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows();
        $this->dataSourceName = 'vnd10000_objetivovenda_dia';
        foreach($rows as $key => &$row){
            $rows[$key]['VROBJDESAFIODIA'] = Util::moneyToDouble($rows[$key]['VROBJDESAFIODIA']);
            $rows[$key]['VROBJREALDIA'] = Util::moneyToDouble($rows[$key]['VROBJREALDIA']);
            $rows[$key]['VRTICKETDIA'] = Util::moneyToDouble($rows[$key]['VRTICKETDIA']);
        }
        if($rows[0]['__is_new']){
            $diasSemana = $rows[0]['NRDIASEMANA'];
            $parans = array(
                "CDFILIAL"=>$rows[0]["CDFILIAL"],
                "CDOBJANO"=>$rows[0]["CDOBJANO"],
                "CDOBJMES"=>$rows[0]["CDOBJMES"],
                "NRORG"=>$rows[0]["NRORG"]
            );
            foreach($diasSemana as $dia){
                $parans["NRDIASEMANA"] = $dia;
                if($this->ObjetivoVendaService->checkRegistroDia($parans)){
                    $row->set('NRDIASEMANA',$dia);
                    parent::save($request,$response);
                }
            }
        }else{
            parent::save($request,$response);
        }   
            
    }
    
    public function deleteObjetivoVendaDiaria(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10000_objetivovenda_dia';
        parent::delete($request,$response);
    }
    
    public function exportarObjetivoVendaMesOverwrite(DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows();
        foreach($rows as $key => &$row){
            $CDFILIAIS   =   $rows[$key]['CDFILIAL'];
            $CDOBJMESES   =   $rows[$key]['CDOBJMES'];
            $CDOBJANO   =   $rows[$key]['CDOBJANO'];
            $VROBJREALMES   =   Util::moneyToDouble($rows[$key]['VROBJREALMES']);
            $VROBJDESAFIOMES    =   Util::moneyToDouble($rows[$key]['VROBJDESAFIOMES']);
            $VRTICKETMES    =   Util::moneyToDouble($rows[$key]['VRTICKETMES']);
            $NRDIASSEMANA    =   $rows[$key]['NRDIASEMANA'];
            $NRORG  =   $this->environment->getNrOrgTrab();
            $CDOPERADOR =   $this->environment->getCdOperador();
            $CDFILIAL_ORIGEM = $rows[$key]['CDFILIAL_ORIGEM'];
            $CDOBJANO_ORIGEM = $rows[$key]['CDOBJANO_ORIGEM'];
            $CDOBJMES_ORIGEM = $rows[$key]['CDOBJMES_ORIGEM'];
            foreach($CDFILIAIS as $CDFILIAL){
                foreach($CDOBJMESES as $CDOBJMES){
                    $this->ObjetivoVendaService->exportObjetivoOverwrite($CDFILIAL,$CDOBJMES,$CDOBJANO,$VROBJREALMES,$VROBJDESAFIOMES,$VRTICKETMES,$NRORG,$CDOPERADOR,$CDFILIAL_ORIGEM,$CDOBJMES_ORIGEM,$CDOBJANO_ORIGEM);
                    foreach($NRDIASSEMANA as $NRDIASEMANA){
                        $this->ObjetivoVendaService->exportObjetivoDiaOverwrite($CDFILIAL,$CDOBJMES,$CDOBJANO,$NRDIASEMANA,$CDFILIAL_ORIGEM,$NRORG,$CDOBJANO_ORIGEM,$CDOBJMES_ORIGEM);
                    }
                }
            }
        }
    }
    
    public function exportarObjetivoVendaMes(DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows();
        foreach($rows as $key => &$row){
            $CDFILIAIS   =   $rows[$key]['CDFILIAL'];
            $CDOBJMESES   =   $rows[$key]['CDOBJMES'];
            $CDOBJANO   =   $rows[$key]['CDOBJANO'];
            $VROBJREALMES   =   Util::moneyToDouble($rows[$key]['VROBJREALMES']);
            $VROBJDESAFIOMES    =  Util::moneyToDouble( $rows[$key]['VROBJDESAFIOMES']);
            $VRTICKETMES    =   Util::moneyToDouble($rows[$key]['VRTICKETMES']);
            $NRDIASSEMANA    =   $rows[$key]['NRDIASEMANA'];
            $NRORG  =   $this->environment->getNrOrgTrab();
            $CDOPERADOR =   $this->environment->getCdOperador();
            $CDFILIAL_ORIGEM = $rows[$key]['CDFILIAL_ORIGEM'];
            $CDOBJANO_ORIGEM = $rows[$key]['CDOBJANO_ORIGEM'];
            $CDOBJMES_ORIGEM = $rows[$key]['CDOBJMES_ORIGEM'];
            foreach($CDFILIAIS as $CDFILIAL){
                foreach($CDOBJMESES as $CDOBJMES){
                    $this->ObjetivoVendaService->exportObjetivoWithoutOverwrite($CDFILIAL,$CDOBJMES,$CDOBJANO,$VROBJREALMES,$VROBJDESAFIOMES,$VRTICKETMES,$NRORG,$CDOPERADOR,$CDFILIAL_ORIGEM,$CDOBJMES_ORIGEM,$CDOBJANO_ORIGEM);
                    foreach($NRDIASSEMANA as $NRDIASEMANA){
                        $this->ObjetivoVendaService->exportObjetivoDiaWithoutOverwrite($CDFILIAL,$CDOBJMES,$CDOBJANO,$NRDIASEMANA,$CDFILIAL_ORIGEM,$NRORG,$CDOBJANO_ORIGEM,$CDOBJMES_ORIGEM);
                    }
                }
            }
        }
    }
    
    public function saveExportarObjetivoVendaMes(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10000_objetivovenda_exportarmes';
        parent::save($request,$response);
    }
    
    public function findObjetivoVendaDiariaAlternativa(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10000_objetivovenda_diaalt';
        parent::find($request,$response);
    }
    
    public function saveObjetivoVendaDiariaAlternativa(DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows();
        $this->dataSourceName = 'vnd10000_objetivovenda_diaalt';
        foreach($rows as $key => &$row){
            $rows[$key]['VROBJDESAFIODIAALT'] = Util::moneyToDouble($rows[$key]['VROBJDESAFIODIAALT']);
            $rows[$key]['VROBJREALDIAALT'] = Util::moneyToDouble($rows[$key]['VROBJREALDIAALT']);
            $rows[$key]['VRTICKETDIAALT'] = Util::moneyToDouble($rows[$key]['VRTICKETDIAALT']);
        }
        parent::save($request,$response);
    }
    
    public function deleteObjetivoVendaDiariaAlternativa(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd10000_objetivovenda_diaalt';
        parent::delete($request,$response);
    }
    
    


    public function saveObjetivoVendaMensal(DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows();
        $date = $rows[0]['CDOBJMES_ANO'];
        foreach($rows as $key => &$row){
            $rows[$key]['CDOBJMES'] = substr($rows[$key]['CDOBJMES_ANO'],0,2);
            $rows[$key]['CDOBJANO'] = substr($rows[$key]['CDOBJMES_ANO'],3);
            $rows[$key]['VROBJREALMES'] = Util::moneyToDouble($rows[$key]['VROBJREALMES']);
            $rows[$key]['VROBJDESAFIOMES'] = Util::moneyToDouble($rows[$key]['VROBJDESAFIOMES']);
            $rows[$key]['VRTICKETMES'] = Util::moneyToDouble($rows[$key]['VRTICKETMES']);
            unset($rows[$key]['CDOBJMES_ANO']); 
        }
        parent::save($request,$response);
    }
    
}