<?php

namespace Teknisa\MAN\Factories\Retail;

use Doctrine\DBAL\Connection;

class Produto extends BaseRepo {
    
    public function getVRPERCACRPROD ($CDFILIAL, $CDPRODUTO) {
        $params = array(
            ':CDFILIAL'       =>  $CDFILIAL,
            ':CDPRODUTO'      =>  $CDPRODUTO,
        );
        
        $result = $this->conn->fetchAll(self::GET_VRPERCPREPRO, $params);

        return empty($result) ? 0.00 : floatval($result[0]['VRPERCPREPRO']);
    }
    
    public function getCDNVPRODUTO ($NRORG) {
        $params = array(
            ':NRORG'          =>  $NRORG
        );
        
        $result = $this->conn->fetchAll(self::GET_MAX_CDNVPRODUTO, $params);
        
        return empty($result) ? null : $result[0]['CDNVPRODUTO'];
    }
    
    const GET_MAX_CDNVPRODUTO = "
        SELECT 
          MAX(CDNVPRODUTO) AS CDNVPRODUTO 
            FROM PRODUTO 
            WHERE NRORG = :NRORG
    ";
    
    const GET_VRPERCPREPRO = "
        SELECT NVL(VRPERCPREPRO, 0.00)
          FROM PERCACRPROD
         WHERE CDFILIAL = :CDFILIAL
           AND CDPRODUTO = :CDPRODUTO
    ";
}